{$mode delphi}

const MAXN = 200; 

type coord = record
  i, j : integer;
end;

function manhatten(const p1, p2 : coord) : integer;
Begin
	manhatten := abs(p1.i-p2.i) + abs(p1.j-p2.j);
End;

var XSz, YSz : integer;
    fdat, fres : text;
    TEST_NUM, the_test : integer;
    k, MAXK : integer;
    C : array[0..(MAXN*MAXN)div 3 , 1..3] of coord;
    num_used : array[0..(MAXN*MAXN)div 3] of integer;
    already_found_bad : boolean;
    curr : integer;
    i, j : integer; 

BEGIN
  assign(fdat, 'triomino.dat'); reset(fdat);
  assign(fres, 'triomino.sol'); rewrite(fres);
  read(fdat, TEST_NUM);
  for the_test := 1 to TEST_NUM do begin
    read(fdat, YSZ, XSZ);
    MAXK := (XSZ*YSZ)div 3;
    for k:=0 to MAXK do
      num_used[k] := 0;

    already_found_bad := false;
    for i:=1 to YSZ do
      for j:=1 to XSZ do begin
        read(fdat, curr);
        if already_found_bad then
          continue;
        inc(num_used[curr]);
        if num_used[curr] > 3 then begin
          already_found_bad := true;
          continue;
        end;
        C[curr][num_used[curr]].i := i;
        C[curr][num_used[curr]].j := j;
      end;
    if not already_found_bad then begin
      for k := 1 to MAXK do
        if num_used[k]<3 then
          already_found_bad := true;
      if not already_found_bad then
        for k:=1 to MAXK do begin
          if manhatten(C[k][1],C[k][2])
          + manhatten(C[k][1],C[k][3])
          + manhatten(C[k][2],C[k][3]) <> 4 then begin
              already_found_bad := true;
              break;
          end;
        end
    end;
    if already_found_bad then
      writeln(fres,'NO')
    else
      writeln(fres,'YES');
  end;
  close(fres);
  close(fdat);
END.
