#include <cstdio>
#include <vector>

using namespace std;

inline int abs(int x)
{
	return x>=0 ? x : (-x);
}

typedef pair<int,int> pii;

inline int manhatten(const pii &p1, const pii &p2)
{
	return abs(p1.first-p2.first) + abs(p1.second-p2.second);
}

int main(int argc, char* argv[])
{
	int XSZ, YSZ;
	FILE *fdat = fopen("triomino.dat", "rt");
	FILE *fres = fopen("triomino.sol", "wt");
	int TEST_NUM;
	fscanf(fdat, "%d", &TEST_NUM);
	for(int the_test = 0; the_test < TEST_NUM; the_test++)
	{
		fscanf(fdat, "%d %d", &YSZ, &XSZ);
		int MAXK = (XSZ*YSZ)/3;

		vector<vector<pii> > coords;
		coords.resize(MAXK+1);

		bool already_found_bad = false;
		for(int i=0; i<YSZ; i++)
			for(int j=0; j<XSZ; j++)
			{
				int curr;
				fscanf(fdat, "%d", &curr);
				if(already_found_bad)
					continue;
				coords[curr].push_back(pii(i,j));
				if(coords[curr].size()>3)
					already_found_bad = true;
			};
		if(!already_found_bad)
		{
			for(int k=1; k<=MAXK; k++)
				if(coords[k].size()<3)
					already_found_bad = true;
			if(!already_found_bad)
				for(int k=1; k<=MAXK; k++)
				{
					int ddd = manhatten(coords[k][0],coords[k][1]) 
						+ manhatten(coords[k][0],coords[k][2]) 
						+ manhatten(coords[k][1],coords[k][2]);
					if(ddd != 4)
					{
						already_found_bad = true;
						break;
					}
				};
		}
		if(already_found_bad)
			fprintf(fres,"NO\n");
		else
			fprintf(fres,"YES\n");
	}
	return 0;
}
