#pragma warning (disable : 4996)

#include <cstdio>
#include <vector>
#include <queue>

using namespace std;

const int MAXN = 200;

FILE *fin, *fout;

struct coord
{
	int i,j;
	coord(int i_, int j_) : i(i_), j(j_) { } ;
};

bool solve_curr_field(void)
{
	static int data[MAXN][MAXN];
	vector<bool> was_searched;
	int YSz, XSz;

	fscanf(fin, "%d %d", &YSz, &XSz);
	int MAX_K = (XSz*YSz)/3;
	was_searched.resize(MAX_K+1, false);

	for(int i=0; i<YSz; i++)
		for(int j=0; j<XSz; j++)
			fscanf(fin, "%d", data[i]+j);
	for(int i=0; i<YSz; i++)
		for(int j=0; j<XSz; j++)
			if(data[i][j] > 0)
			{
				int current_color = data[i][j];
				if(was_searched[current_color])
					return false;
				was_searched[current_color] = true;
				data[i][j] = -data[i][j];
				queue<coord> qqq;
				qqq.push(coord(i,j));
				int figure_size = 1;
				while(!qqq.empty() && figure_size <= 3) // where 3 is triomino size, can be changed
				{
					coord curr = qqq.front();
					qqq.pop();
					static const int di[4] = {0, 1, 0, -1};
					static const int dj[4] = {1, 0, -1, 0};
					for(int d = 0; d < 4; d++)
					{
						coord nabour(curr.i + di[d], curr.j + dj[d]);
						if(nabour.i >= 0 && nabour.i < YSz && nabour.j >= 0 && nabour.j < XSz && data[nabour.i][nabour.j] == current_color)
						{
							qqq.push(nabour);
							figure_size++;
							data[nabour.i][nabour.j] = -data[nabour.i][nabour.j];
						}
					}
				}
				if(figure_size!=3)
					return false;
			};
	for(int k=1; k<=MAX_K; k++)
		if(!was_searched[k])
			return false;
	return true;
}

int main(int argc, char* argv[])
{
	fin = fopen("triomino.dat", "rt");
	fout = fopen("triomino.sol", "wt");
	int TEST_NUM;
	fscanf(fin, "%d", &TEST_NUM);
	for(int the_test=0; the_test < TEST_NUM; the_test++)
		if(solve_curr_field())
			fprintf(fout, "YES\n");
		else
			fprintf(fout, "NO\n");
	fclose(fin);
	return 0;
}

